=== OptionalDependencies/flif/Makefile ===
all:
	cd src && $(MAKE)

flif:
	cd src && $(MAKE) flif

install:
	cd src && $(MAKE) install

install-dev:
	cd src && $(MAKE) install-dev
